#pragma once
#include "AreaPacket.h"

/** Packet Class that carries location information

*** TODO is CoordPacket the same as WMAreaPacket???

	@ingroup data
*/
class CoordPacket :
	public WMPacket
{
public:
	virtual PacketPointer Clone() const;
	CoordPacket &operator=(const CoordPacket &other);

	virtual size_t getHeapUsage() { return 0;	};
	static WorldMachine::PacketType getStaticType() { return WorldMachine::Packet::coord; };
	virtual WorldMachine::PacketType getType() const { return getStaticType(); };
	virtual const char *getTypeName() const { return "Coordinate"; };
	virtual bool queryType(WorldMachine::PacketType const&type) const;	

	virtual bool Load(std::istream &input);
	virtual bool Save(std::ostream &output);

	virtual dword Color() { return 0x0ffff00; };
	virtual void Clear();

	CoordF get() { return location; };
	void set(CoordF &_l) { location = _l; };

//	PacketContext &getContext() { return sd; };

protected:
	friend class WMPacketFactory;
	CoordPacket();
	virtual ~CoordPacket();
	virtual void resetContents() { };

	CoordF	location;		// coordinates
	int coord_mode;			// 0 = world, 1 = local
};

/// Safe Packet Cast function 
/// @relates CoordPacket
inline CoordPointer LOC(PacketPointer const & pack) { 
	if (pack) {
		bool ok = pack->getType() == WorldMachine::Packet::coord;
		assert(ok);
		if (!ok)
			return NULL;
	}
	return CoordPointer((CoordPacket*) pack.get()); 
};
